Y_csgoto 2019-12-05 20:48 采纳率: 57.1%
浏览 544
已采纳

为什么Java书中实现Java异常链时,在catch{}模块中已经用throw再次抛出了一个异常,却还要在方法定义时throws这个类的异常?

最近学习了Java的异常链机制,发现了一个问题,就是作者实现Java异常链的时候总是在方法定义处throws方法体中已经throw过实例的异常类,显得有些赘余,我想请问这是在干什么,throws和throw不配套使用也不会出错,这样做只是为了什么?以为了后能看得懂?

public class ExceptionList {

    public void firstStep() throws MyException{
        throw new MyException();
    }
    //这里又throws了catch子句里已经抛出的异常
    public void SecondStep() throws AutoDefinedRuntimeException{
        try {
            ExceptionList eList = new ExceptionList();
            eList.firstStep();
        }
        catch(MyException me1) {
            //me1.getMessage();
            me1.printStackTrace();
            throw new AutoDefinedRuntimeException(me1);//抛出更高级的异常
        }
    }


    public static void main(String[] args) {
        // TODO Auto-generated method stub
        try{
            ExceptionList eList = new ExceptionList();
            eList.SecondStep();
        }
        catch(AutoDefinedRuntimeException me2) {
            //me2.getMessage();
            me2.printStackTrace();
        }
    }

}

  • 写回答

2条回答 默认 最新

  • 毕小宝 博客专家认证 2019-12-06 09:28
    关注

    既然 catch 了但是不处理而往上层跑,那么就没有必要用 catch 直接抛就可以了。
    Java 语法规定的代码中但凡使用 throws 抛出异常的都需要在方法定义的时候声明。

    本回答被题主选为最佳回答 , 对您是否有帮助呢?
    评论
查看更多回答(1条)

报告相同问题?

悬赏问题

  • ¥15 请问1553 RT怎么测试,没有BC有方法吗
  • ¥100 业务编程如何选择学习方向和内容?
  • ¥15 wamp3.3.5安装完成后图标正常显示绿色,鼠标左右键点击图标均无反应。求解决方法。
  • ¥15 鼠标点击的这条记录了什么?
  • ¥15 在写pid调速的程序时,电机始终维持最大速度
  • ¥15 【有偿】调用DXGI截图初始化失败,提示0xf 887a0004
  • ¥15 请问如何查看手机root记录?
  • ¥15 商城小程序订单号重复
  • ¥15 学校优化算法sbo和蚁群算法怎么结合
  • ¥21 matlab怎么求时域信号的二阶导数